TITLE Listing1.asm
;* Programm beschreibt die Abfrage des Gertetyps und zeigt
;* die Arbeitsweise des OUTS-Befehls.  Im Beispiel wird ein
;* Byte direkt an den Tastaturprozessor (8042) geschickt.
;* Dabei lst 0FEh -> 254 dezimal einen RESET aus.

Ausgabe MACRO Text
     mov ax, CS
     mov DS, ax
     mov ah, 09
     mov dx, offset CS:Text
     int 21h
ENDM 

;----------------------------------------------------------

.model small
.stack
.code

ID_Byte   DB '?'
XT_Text   DB 'Programm luft nur mit 80286/386/486 Rechnern'
          DB ' im erweiterten Real Mode!', 13, 10, '$'
Daten     DB 254 

;------------------ Unterprogramme -------------------------

who_am_i proc
     push ax
     push bx                            
     mov ax,0F000h                      ;Offset ID-Byte
     mov ES,ax
     mov bl, ES:0FFFEh
     mov CS:ID_Byte,bl
     pop bx
     pop ax
     ret     
who_am_i endp

;------------------ Hauptprogramm --------------------------
.8086                         ;Real-Mode

Start: 
     call who_am_i
     mov al, CS:ID_Byte
     cmp al, 0FFh             ;PC 8086 ?
     je kein_AT 
     cmp al, 0FEh             ;PC/XT ?
     je kein_AT
     cmp al, 0FBh             ;256/640 KB System ?
     je kein_AT
     jmp Real_Mode
kein_AT:
     Ausgabe XT_Text
     jmp Ende

;--- ab hier kann im erweiterten Real Mode gearbeitet werden     

Real_Mode:
.286          

     cld                      ;clear Direction Flag
     mov ax,SEG Daten         ;Segmentadresse Daten
     mov ds,ax                
     mov si,OFFSET Daten      ;Offsetadresse Daten
     mov dx,64h               ;Portadresse (Tastatur)
     mov cx,1                 ;Zhlervar, 1 Byte bertragen
     REP outsb                ;cx mal jeweils ein Byte
                              ;an die Portadresse, wenn
                              ;Wortgre dann outsw
                              ;si wird autom. erhht
     hlt                      ;hier ist Schlu,erwarte RESET     
Ende:
     mov ah,4Ch               ;zurck zu DOS
     int 21h            
end Start